using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Controles;
using Exferia_Controles.ControlesAuxiliares;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_Ventas._0_Modelos;
using Exferia_Ventas._3_Vistas.Controladoras;
using Exferia_Ventas.General;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Ventas._3_Vistas
{
    public partial class P_RemesaLinea : Exferia_Formularios.P_Base_Mantenimientos
    {
        #region Variables General
        private P_RemesaLinea_Controladora g_obj_Controladora;

        private bool g_bol_ConstructorPantalla_Terminado_Correctamente = true;
        public PRV_OpcionesDetalle g_mdl_PRV_OpcionesDetalle = null;

        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;

        //Variables paginador......................................................................................
        public Funciones_Paginador g_obj_Funciones_Paginador;
        private System.Windows.Forms.Timer g_timer_Paginar = new System.Windows.Forms.Timer();
        #endregion

        #region Objetos en Pantalla

        // CTU_Cartera_Ventas
        internal CTU_Cartera_Ventas CTU_Cartera_Ventas_Remesalinea { get { return ctu_P_Remesalinea_CarteraVentas; } }

        //Exferia_CheckBox
        internal Exferia_CheckBox Exferia_CheckBox_Bloqueo { get { return ex_chk_P_RemesaLinea_Bloqueo; } }
        internal Exferia_CheckBox Exferia_CheckBox_Contabilizado { get { return ex_chk_P_RemesaLinea_Contabilizado; } }

        //Exferia_F3
        internal Exferia_F3 Exferia_F3_Cliente { get { return ex_usc_F3_P_RemesaLinea_Cliente; } }
        internal Exferia_F3 Exferia_F3_Delegacion { get { return ex_usc_F3_P_RemesaLinea_Delegacion; } }
        internal Exferia_F3 Exferia_F3_Vencimiento { get { return ex_usc_F3_P_RemesaLinea_Vencimiento; } }
        internal Exferia_F3 Exferia_F3_CuentaBancaria { get { return ex_usc_F3_P_RemesaLinea_CuentaBancaria; } }

        //Exferia_F3_SoloSeleccion
        internal Exferia_F3_SoloSeleccion Exferia_F3_SoloSeleccion_Ejercicio { get { return ex_usc_F3_P_RemesaLinea_Ejercicio; } }
        
        //Exferia_F3_SoloSeleccion_Simple
        internal Exferia_F3_SoloSeleccion_Simple Exferia_F3_SoloSeleccion_Simple_FacturaCabecera { get { return ex_usc_F3_P_RemesaLinea_FacturaCabecera; } }

        // Exferia_Label
        internal Exferia_Label Exferia_Label_Concepto { get { return ex_lbl_P_RemesaLinea_Concepto; } }
        internal Exferia_Label Exferia_Label_IBAN_TITULO { get { return ex_lbl_P_RemesaLinea_IBAN_TITULO; } }

        //Exferia_Label_SinColor
        internal Exferia_Label_SinColor Exferia_Label_SinColor_IBAN_VALOR { get { return ex_lbl_P_RemesaLinea_IBAN_VALOR; } }
        internal Exferia_Label_SinColor Exferia_Label_SinColor_Advertencia_Ejercicio { get { return ex_lbl_Advertencia_Ejercicio; } }

        //Exferia_RadioButton
        internal Exferia_RadioButton Exferia_RadioButton_Recurrente { get { return ex_rdb_P_RemesaLinea_Recurrente; } }
        internal Exferia_RadioButton Exferia_RadioButton_Unico { get { return ex_rdb_P_RemesaLinea_Unico; } }
        internal Exferia_RadioButton Exferia_RadioButton_Posicion_Primero { get { return ex_rdb_P_RemesaLinea_Posicion_Primero; } }
        internal Exferia_RadioButton Exferia_RadioButton_Posicion_Recurrente { get { return ex_rdb_P_RemesaLinea_Posicion_Recurrente; } }
        internal Exferia_RadioButton Exferia_RadioButton_Posicion_Ultimo { get { return ex_rdb_P_RemesaLinea_Posicion_Ultimo; } }

        // Exferia_TextBox
        internal Exferia_TextBox Exferia_TextBox_Concepto { get { return ex_txt_P_RemesaLinea_Concepto; } }
        internal Exferia_TextBox Exferia_TextBox_Importe { get { return ex_txt_P_RemesaLinea_Importe; } }

        // Panel
        internal Panel Panel_DatosCuentasBancarias { get { return pnl_DatosCuentasBancarias; } }
        internal Panel Panel_Posicion { get { return pnl_Posicion; } }

        #endregion

        #region Constructor
        public P_RemesaLinea(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo, 
                            DateTime _dtt_FechaTrabajo, 
                            PRV_OpcionesDetalle _mdl_PRV_OpcionesDetalle, 
                            INTERNO_VTA_RemesasCabecera_Modelo _mdl_INTERNO_VTA_RemesasCabecera_Modelo,
                            List<INTERNO_VTA_RemesasAcumulados_Listado_Modelo> _lst_INTERNO_VTA_RemesasAcumulados_Listado_Modelo,
                            string _str_Estado,
                            G_ENUM_VALIDACIONFECHAS_TIPOCIERRE _obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE)
        {
            InitializeComponent();
            try
            {
                Repintar.Empezar(this);

                CheckForIllegalCrossThreadCalls = false;

                //Empresa seleccionada y fecha de trabajo ....................................................
                P_Base_ValoresGenerales = _mdl_INTERNO_ValoresGenerales_Modelo;
                P_Base_FechaTrabajo = _dtt_FechaTrabajo;

                //Instanciar Controladora
                g_obj_Controladora = new P_RemesaLinea_Controladora(this);

                g_obj_Controladora.g_lst_INTERNO_VTA_RemesasAcumulados_Listado_Modelo = _lst_INTERNO_VTA_RemesasAcumulados_Listado_Modelo;
                g_obj_Controladora.g_mdl_INTERNO_VTA_RemesasCabecera_Modelo = _mdl_INTERNO_VTA_RemesasCabecera_Modelo;
                g_obj_Controladora.g_str_Estado = _str_Estado;
                g_obj_Controladora.g_obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE= _obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE;

                //Ejercicio Actual
                g_obj_Controladora.g_mdl_GEN_EjerciciosActivos_Empresa = Variables.G_MDL_INTERNO_VALORESGENERALES_MODELO.EjercicioActivo;

                //Datos de Opciones detalle
                g_mdl_PRV_OpcionesDetalle = _mdl_PRV_OpcionesDetalle;

                //Buscar los Permisos
                g_lst_INTERNO_Permisos_Modelo = Datos_Generales.Permisos_Buscar(g_mdl_PRV_OpcionesDetalle.opcion);

                //Poner los Botones que no se Spueden poner bloqueados o de solo lectura
                ex_btn_P_RemesaLinea_Borrar.Exferia_Button_Bloqueable = false;
                ex_btn_P_RemesaLinea_Grabar.Exferia_Button_Bloqueable = false;

                //Mirar si hay que bloquear los controles, si solo puede ver los datos
                if ((P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, false)) == false)
                {
                    //Bloqueo los Controles
                    SoloLectura.Empezar(this, true);
                }

                //Titulo de la Pantalla .............................................................................
                P_Base_TituloPantalla = _mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento;

                // Label con Empresa Seleccionada 
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                                "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";
                    }
                    catch (Exception ex)
                    {
                        //No se muestra mensaje pero se guarda en el log
                        Control_Errores.Errores_Log("", ex, nameof(P_RemesaLinea) + "/" + nameof(P_RemesaLinea));
                    }
                }
                //....................................................................................................

                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = false;
                //.............................................................

                g_obj_Funciones_Paginador = new Funciones_Paginador();

                //Rellenar para los F3 .......................................
                //EJERCICIO
                ex_usc_F3_P_RemesaLinea_Ejercicio.Exferia_F3_SoloSeleccion_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_GEN_EJERCICIOACTIVO;
                ex_usc_F3_P_RemesaLinea_Ejercicio.Exferia_F3_SoloSeleccion_PantallaContenedora = this;
                ex_usc_F3_P_RemesaLinea_Ejercicio.Exferia_F3_SoloSeleccion_PRINCIPAL_BUSCARTITULO = false;
                
                //CLIENTE
                ex_usc_F3_P_RemesaLinea_Cliente.Exferia_F3_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_MAE_CLIENTE;
                ex_usc_F3_P_RemesaLinea_Cliente.Exferia_F3_PantallaContenedora = this;
               
                //DELEGACION
                ex_usc_F3_P_RemesaLinea_Delegacion.Exferia_F3_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_GEN_DELEGACION;
                ex_usc_F3_P_RemesaLinea_Delegacion.Exferia_F3_PantallaContenedora = this;

                //FACTURACABECERA
                ex_usc_F3_P_RemesaLinea_FacturaCabecera.Exferia_F3_SoloSeleccion_Simple_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_VTA_FACTURACABECERA;
                ex_usc_F3_P_RemesaLinea_FacturaCabecera.Exferia_F3_SoloSeleccion_Simple_PantallaContenedora = this;

                //VENCIMIENTO
                ex_usc_F3_P_RemesaLinea_Vencimiento.Exferia_F3_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_VTA_VENCIMIENTO;
                ex_usc_F3_P_RemesaLinea_Vencimiento.Exferia_F3_PantallaContenedora = this;
                
                //Filtro para que solo salgan los Pendientes ...............................................
                Dictionary<string,object> dct_ListadoFiltros = new Dictionary<string, object>();
                INTERNO_Listado_Filtros_Opciones_Modelo mdl_INTERNO_Listado_Filtros_Opciones_Modelo = new INTERNO_Listado_Filtros_Opciones_Modelo();
                mdl_INTERNO_Listado_Filtros_Opciones_Modelo.CAMPO = nameof(INTERNO_VTA_Vencimientos_Listado_Modelo.Pendiente);
                mdl_INTERNO_Listado_Filtros_Opciones_Modelo.VALOR_TEXTO = new List<string>();
                mdl_INTERNO_Listado_Filtros_Opciones_Modelo.VALOR_TEXTO.Add(Variables_Ventas.G_MDL_VENCIMIENTOS_PARTEPENDIENTE.Codigo);
                mdl_INTERNO_Listado_Filtros_Opciones_Modelo.VALOR_TEXTO.Add(Variables_Ventas.G_MDL_VENCIMIENTOS_TOTALPENDIENTE.Codigo);
                dct_ListadoFiltros.Add(nameof(INTERNO_VTA_Vencimientos_Listado_Modelo.Pendiente), mdl_INTERNO_Listado_Filtros_Opciones_Modelo);
                ex_usc_F3_P_RemesaLinea_Vencimiento.Exferia_F3_FiltrosAvanzados = dct_ListadoFiltros;
                //.............................................................................................

                //CUENTA BANCARIA
                ex_usc_F3_P_RemesaLinea_CuentaBancaria.Exferia_F3_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_MAE_CUENTABANCARIA_CLIENTE;
                ex_usc_F3_P_RemesaLinea_CuentaBancaria.Exferia_F3_PantallaContenedora = this;
                ex_usc_F3_P_RemesaLinea_CuentaBancaria.Exferia_F3_PRINCIPAL_BUSCARTITULO = false;
            }
            catch (Control_Errores)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
            catch (Exception ex)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;

                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_RemesaLinea) + "/" + nameof(P_RemesaLinea));
            }
            finally
            {
                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = true;
                //.............................................................
            }
        }
        #endregion

        #region Inicio de pantalla
        private void P_RemesaLinea_Load(object sender, EventArgs e)
        {
            try
            {
                #region PAGINACION
                g_timer_Paginar.Interval = 1000;
                g_timer_Paginar.Tick += delegate (object s, EventArgs ee)
                {
                    g_timer_Paginar.Stop();
                    try
                    {
                        g_obj_Controladora.RecargarDatos();
                    }
                    catch (Control_Errores)
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                        Salir_P_Base();
                    }
                };
                #endregion

                #region Resumen Facturas
                ctu_P_Remesalinea_CarteraVentas.Inicializar_Control(P_Base_ValoresGenerales, P_Base_FechaTrabajo, this);
                #endregion
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_RemesaLinea) + "/" + nameof(P_RemesaLinea_Load));

                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
        }

        private void P_RemesaLinea_Shown(object sender, EventArgs e)
        {
            try
            {
                if (g_bol_ConstructorPantalla_Terminado_Correctamente)
                {
                    // Si el Tipo de Apertura de Pantalla es Añadir(g_int_tipoAperturaPantalla = 0), se desactivan los botones correspondientes
                    // Añadir
                    if (this.P_Base_TipoAperturaPantalla == 0)
                    {

                        P_Base_TituloPantalla = P_Base_TituloPantalla + " - Añadir";

                        g_obj_Controladora.Datos_PorDefecto();

                        ActivarBotones(false);

                        //Se cambia el valor de la variable para no salte el evento de se modifico algo
                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = false;

                        //Poner Texto predeterminado y foco
                        ex_usc_F3_P_RemesaLinea_Cliente.Exferia_F3_Foco();

                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = true;

                    }
                    // Modificar
                    else
                    {
                        ActivarBotones(true);

                        g_obj_Controladora.RecargarDatos();
                    }
                }
                else
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                    Salir_P_Base();
                }
            }
            catch (Control_Errores)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_RemesaLinea) + "/" + nameof(P_RemesaLinea_Shown));

                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
        }
        public void ActivarBotones(bool _bol_Activar)
        {
            if (ex_btn_P_RemesaLinea_Borrar.Enabled)
            {
                ex_btn_P_RemesaLinea_Borrar.Enabled = _bol_Activar;
            }
        }
        #endregion

        #region Ejercicio
        private void ex_usc_F3_P_RemesaLinea_Ejercicio_Exferia_F3_SoloSeleccion_Evento_TerminoBusqueda(object sender, EventArgs e)
        {
            //Tiene un Ejercicio Seleccionado correcto
            if (ex_usc_F3_P_RemesaLinea_Ejercicio.Exferia_F3_SoloSeleccion_Id > -1)
            {
                //Desbloqueamos la busqueda del documento
                if (!g_obj_Controladora.g_lng_idEjercicio.Equals(ex_usc_F3_P_RemesaLinea_Ejercicio.Exferia_F3_SoloSeleccion_Id))
                {
                    g_obj_Controladora.g_lng_idEjercicio = ex_usc_F3_P_RemesaLinea_Ejercicio.Exferia_F3_SoloSeleccion_Id;

                    g_obj_Controladora.Bloquea_Desbloquea(P_RemesaLinea_Controladora.G_ENUM_NIVELES.Factura, P_RemesaLinea_Controladora.G_ENUM_ACCIONES_BLOQUEO.Desbloquear_SiActual);

                    g_obj_Controladora.FacturaCabecera_Actualizar_DatosFiltro();
                }
            }
            else
            {
                //Vaciamos y bloqueamos el Documento y todos los datos relacionados
                g_obj_Controladora.g_lng_idEjercicio = -1;

                ex_usc_F3_P_RemesaLinea_FacturaCabecera.Exferia_F3_SoloSeleccion_Simple_RELACIONADOS = null;

                g_obj_Controladora.Bloquea_Desbloquea(P_RemesaLinea_Controladora.G_ENUM_NIVELES.Factura, P_RemesaLinea_Controladora.G_ENUM_ACCIONES_BLOQUEO.Bloquear_SiActual);
            }
        }
        #endregion

        #region Delegacion
        private void ex_usc_F3_P_RemesaLinea_Delegacion_Exferia_F3_Evento_TerminoBusqueda(object sender, EventArgs e)
        {
            //Tiene una Delegacion Seleccionada correcto
            if (ex_usc_F3_P_RemesaLinea_Delegacion.Exferia_F3_Id > -1)
            {
                //Desbloqueamos la busqueda del documento
                if (!g_obj_Controladora.g_lng_idDelegacion.Equals(ex_usc_F3_P_RemesaLinea_Delegacion.Exferia_F3_Id))
                {
                    g_obj_Controladora.g_lng_idDelegacion = ex_usc_F3_P_RemesaLinea_Delegacion.Exferia_F3_Id;

                    g_obj_Controladora.Bloquea_Desbloquea(P_RemesaLinea_Controladora.G_ENUM_NIVELES.Factura, P_RemesaLinea_Controladora.G_ENUM_ACCIONES_BLOQUEO.Desbloquear_SiActual);

                    g_obj_Controladora.FacturaCabecera_Actualizar_DatosFiltro();
                }
            }
            else
            {
                //Vaciamos y bloqueamos el Documento y todos los datos relacionados
                g_obj_Controladora.g_lng_idDelegacion = -1;

                ex_usc_F3_P_RemesaLinea_FacturaCabecera.Exferia_F3_SoloSeleccion_Simple_RELACIONADOS = null;

                g_obj_Controladora.Bloquea_Desbloquea(P_RemesaLinea_Controladora.G_ENUM_NIVELES.Factura, P_RemesaLinea_Controladora.G_ENUM_ACCIONES_BLOQUEO.Desbloquear_SiActual);

                g_obj_Controladora.FacturaCabecera_Actualizar_DatosFiltro();
            }
        }

        #endregion

        #region Entidad(Cliente )
        private void ex_usc_F3_P_RemesaLinea_Cliente_Exferia_F3_Evento_TerminoBusqueda(object sender, EventArgs e)
        {
            //Tiene una entidad Seleccionada correcto
            if (ex_usc_F3_P_RemesaLinea_Cliente.Exferia_F3_Id > -1)
            {
                //Desbloqueamos la busqueda del documento
                if (!g_obj_Controladora.g_lng_idEntidad.Equals(ex_usc_F3_P_RemesaLinea_Cliente.Exferia_F3_Id))
                {
                    g_obj_Controladora.g_lng_idEntidad = ex_usc_F3_P_RemesaLinea_Cliente.Exferia_F3_Id;
                }
            }
            else
            {
                //Vaciamos y bloqueamos el Documento y todos los datos relacionados
                g_obj_Controladora.g_lng_idEntidad = -1;
            }

            g_obj_Controladora.FacturaCabecera_Actualizar_DatosFiltro();
        }

        #endregion

        #region FacturasCabecera
        private void ex_usc_F3_P_RemesaLinea_FacturaCabecera_Exferia_F3_SoloSeleccion_Simple_Evento_TerminoBusqueda(object sender, EventArgs e)
        {
            //Tiene un FacturaCabecera Seleccionado correcto
            if (ex_usc_F3_P_RemesaLinea_FacturaCabecera.Exferia_F3_SoloSeleccion_Simple_Id > -1)
            {
                //Desbloqueamos la busqueda del documento
                if ((g_obj_Controladora.g_mdl_INTERNO_VTA_FacturasCabecera_Modelo == null) ||
                    (g_obj_Controladora.g_mdl_INTERNO_VTA_FacturasCabecera_Modelo != null && !g_obj_Controladora.g_mdl_INTERNO_VTA_FacturasCabecera_Modelo.id.Equals(ex_usc_F3_P_RemesaLinea_Ejercicio.Exferia_F3_SoloSeleccion_Id)))
                {
                    g_obj_Controladora.Bloquea_Desbloquea(P_RemesaLinea_Controladora.G_ENUM_NIVELES.VencimentoCuentaBancaria, P_RemesaLinea_Controladora.G_ENUM_ACCIONES_BLOQUEO.Desbloquear_SiActual);

                    //Rellenar Valores
                    g_obj_Controladora.Rellenar_Datos_FacturaCabecera(ex_usc_F3_P_RemesaLinea_FacturaCabecera.Exferia_F3_SoloSeleccion_Simple_Id);

                    //Actualizar el control de Resumen de Facturas
                    ctu_P_Remesalinea_CarteraVentas.Rellenar_DataGrid(G_ENUM_CTU_CARTERA_VENTAS_TIPODOCUMENTOFILTRO.FacturasCabeceraVenta, ex_usc_F3_P_RemesaLinea_FacturaCabecera.Exferia_F3_SoloSeleccion_Simple_Id, true);
                }
            }
            else
            {
                g_obj_Controladora.Vaciar_Datos(P_RemesaLinea_Controladora.G_ENUM_NIVELES.VencimentoCuentaBancaria, P_RemesaLinea_Controladora.G_ENUM_ACCIONES_VACIADO.Vaciar_SiActual, false, true);
                g_obj_Controladora.Bloquea_Desbloquea(P_RemesaLinea_Controladora.G_ENUM_NIVELES.VencimentoCuentaBancaria, P_RemesaLinea_Controladora.G_ENUM_ACCIONES_BLOQUEO.Bloquear_SiActual);

                //Actualizar el control de Resumen de Facturas
                ctu_P_Remesalinea_CarteraVentas.Rellenar_DataGrid(G_ENUM_CTU_CARTERA_VENTAS_TIPODOCUMENTOFILTRO.FacturasCabeceraVenta, -1, true);
            }
        }
        #endregion

        #region Vencimiento
        private void ex_usc_F3_P_RemesaLinea_Vencimiento_Exferia_F3_Evento_TerminoBusqueda(object sender, EventArgs e)
        {
            //Tiene una Vencimiento Seleccionada correcto
            if (ex_usc_F3_P_RemesaLinea_Vencimiento.Exferia_F3_Id > -1)
            {
                //Desbloqueamos la busqueda del documento
                if ((g_obj_Controladora.g_mdl_INTERNO_VTA_Vencimientos_Modelo == null) ||
                    (g_obj_Controladora.g_mdl_INTERNO_VTA_Vencimientos_Modelo != null && !g_obj_Controladora.g_mdl_INTERNO_VTA_Vencimientos_Modelo.id.Equals(ex_usc_F3_P_RemesaLinea_Vencimiento.Exferia_F3_Id)))
                {
                    g_obj_Controladora.Rellenar_Datos_Vencimiento(ex_usc_F3_P_RemesaLinea_Vencimiento.Exferia_F3_Id);
                }
            }
            else
            {
                g_obj_Controladora.Vaciar_Datos(P_RemesaLinea_Controladora.G_ENUM_NIVELES.VencimentoCuentaBancaria, P_RemesaLinea_Controladora.G_ENUM_ACCIONES_VACIADO.Vaciar_SiActual, false, true);
            }
        }

        #endregion

        #region CuentaBancaria
        private void ex_usc_F3_P_RemesaLinea_CuentaBancaria_Exferia_F3_Evento_TerminoBusqueda(object sender, EventArgs e)
        {
            //Tiene un CuentaBancaria Seleccionado correcto
            if (ex_usc_F3_P_RemesaLinea_CuentaBancaria.Exferia_F3_Id > -1)
            {
                //Desbloqueamos la busqueda del documento
                if ((g_obj_Controladora.g_mdl_MAE_CuentasBancariasSEPA_Cobros == null) ||
                    (g_obj_Controladora.g_mdl_MAE_CuentasBancariasSEPA_Cobros != null && !g_obj_Controladora.g_mdl_MAE_CuentasBancariasSEPA_Cobros.id.Equals(ex_usc_F3_P_RemesaLinea_CuentaBancaria.Exferia_F3_Id)))
                {
                    //Rellenar Valores
                    g_obj_Controladora.Rellenar_Datos_CuentaBancaria(ex_usc_F3_P_RemesaLinea_CuentaBancaria.Exferia_F3_Id);
                }
            }
            else
            {
                //Desbloquear pOsicion
                pnl_Posicion.Enabled = false;
                ex_lbl_P_RemesaLinea_IBAN_VALOR.Text = "";
                g_obj_Controladora.g_mdl_MAE_CuentasBancariasSEPA_Cobros = null;
            }
        }
        #endregion

        #region Botones Grabar,Borrar
        private void ex_btn_P_RemesaLineaGrabar_Click(object sender, EventArgs e)
        {
            Grabar();
        }
        private void Grabar()
        {
            if (g_obj_Controladora.g_obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE.Equals(G_ENUM_VALIDACIONFECHAS_TIPOCIERRE.CierreAdministrativo))
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_FECHASEJERCICIOS_ETIQUETA_TIENECIERREADMINISTRATIVO());
            }
            else if (g_obj_Controladora.g_obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE.Equals(G_ENUM_VALIDACIONFECHAS_TIPOCIERRE.CierreContable))
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_FECHASEJERCICIOS_ETIQUETA_TIENECIERRECONTABLE());
            }
            else
            {
                if (//Añadir
                 (P_Base_TipoAperturaPantalla == 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)) ||
                 //Modificar
                 (P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, true)))
                {

                    //Ver el estado del Documento
                    if (g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_VOLCADO))
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_DOCUMENTO_VOLCADO());
                    }
                    else if (g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_CERRADO))
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_DOCUMENTO_CERRADO());
                    }
                    else
                    {
                        //Ver si tiene lineas de Acumulados
                        if (g_obj_Controladora.g_lst_INTERNO_VTA_RemesasAcumulados_Listado_Modelo == null || g_obj_Controladora.g_lst_INTERNO_VTA_RemesasAcumulados_Listado_Modelo.Count == 0)
                        {
                            g_obj_Controladora.GrabarDatos();
                        }
                        else
                        {
                            Mensajes.MostrarMensaje(Mensajes.G_STR_PREMESACABECERA_VALIDACION_ACUMULADOS_HAYLINEAS());
                        }

                    }
                }
            }
        }

        private void ex_btn_P_RemesaLinea_Borrar_Click(object sender, EventArgs e)
        {
            Borrar();
        }
        private void Borrar()
        {
            if (g_obj_Controladora.g_obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE.Equals(G_ENUM_VALIDACIONFECHAS_TIPOCIERRE.CierreAdministrativo))
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_FECHASEJERCICIOS_ETIQUETA_TIENECIERREADMINISTRATIVO());
            }
            else if (g_obj_Controladora.g_obj_ENUM_VALIDACIONFECHAS_TIPOCIERRE.Equals(G_ENUM_VALIDACIONFECHAS_TIPOCIERRE.CierreContable))
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_FECHASEJERCICIOS_ETIQUETA_TIENECIERRECONTABLE());
            }
            else
            {
                if (Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
                {
                    //Ver el estado del Documento
                    if (g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_VOLCADO))
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_DOCUMENTO_VOLCADO());
                    }
                    else if (g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_CERRADO))
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_DOCUMENTO_CERRADO());
                    }
                    else
                    {
                        //Ver si tiene lineas de Acumulados
                        if (g_obj_Controladora.g_lst_INTERNO_VTA_RemesasAcumulados_Listado_Modelo == null || g_obj_Controladora.g_lst_INTERNO_VTA_RemesasAcumulados_Listado_Modelo.Count == 0)
                        {
                            g_obj_Controladora.BorrarDatos();
                        }
                        else
                        {
                            Mensajes.MostrarMensaje(Mensajes.G_STR_PREMESACABECERA_VALIDACION_ACUMULADOS_HAYLINEAS());
                        }
                    }
                }
            }
        }
        
        #endregion

        #region Controlar si se modifica algo

        private void Controlar_Modificaciones_TextBox_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_CheckBox_CheckedChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_Exferia_FechaSeleccion_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones()
        {
            if (Enabled && g_obj_Controladora != null && g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial)
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }


        #endregion

        #region Teclas de acceso rapido

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // Salir sin Seleccionar
            if (keyData == Keys.F10)
            {
                Salir_P_Base();
                return true;
            }
            // Grabar
            else if (keyData == Keys.F2)
            {
                Grabar();
                return true;
            }
            // Borrar
            else if (keyData == Keys.F5)
            {
                Borrar();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }
        #endregion

       
    }
}
